<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class ConformidadesFactory
{

    protected $connection;

    public function __construct(EntityManager $entityManager)
    {

        $this->connection = $entityManager->getConnection();
    }

    // requisição dos dados do card de não conformidades
    public function getDadosCardFactory($param)
    {

        $sql = "SELECT LC.NMLOCALCLIENTE || ' | ' || TLC.NMTIPOLOCALCLI AS NMLOCAL, CTAC.NMCRITERIOTARGERCHK
                  FROM FCM_CRITERIOTARGERCHK CTAC
                  JOIN FCM_TAREFAGERCHK TAC
                    ON CTAC.NRTAREFAGERCHK = TAC.NRTAREFAGERCHK
                  JOIN FCM_GERENCIAMENTOCHK GC
                    ON TAC.NRGERENCIAMENTOCHK = GC.NRGERENCIAMENTOCHK
                  JOIN FCM_LOCALCLI LC
                    ON GC.NRLOCALCLIENTE = LC.NRLOCALCLIENTE
                  JOIN FCM_TIPOLOCALCLI TLC
                    ON LC.NRTIPOLOCALCLI = TLC.NRTIPOLOCALCLI
                  JOIN FCM_CRITERIOTAREFACHK CTC
                    ON CTAC.NRCRITERIOTAREFACHK = CTC.NRCRITERIOTAREFACHK
                  JOIN FCM_CRITERIOTAREFA CT
                    ON CTC.NRCRITERIOTAREFA = CT.NRCRITERIOTAREFA
                 WHERE CTAC.IDMARCADO = 'S'" . $param . "";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function getDadosCardPrincipaisNaoConformidades($param)
    {

        $sql = "SELECT CTCGK.NMCRITERIOTARGERCHK, COUNT(CTCGK.NRCRITERIOTAREFACHK) AS QUANTIDADE
              FROM FCM_CRITERIOTARGERCHK CTCGK
              JOIN FCM_TAREFAGERCHK TGCHK
              ON TGCHK.NRTAREFAGERCHK = CTCGK.NRTAREFAGERCHK
              WHERE IDMARCADO = 'S'" . $param . "
              GROUP BY CTCGK.NMCRITERIOTARGERCHK, CTCGK.NRCRITERIOTAREFACHK
              ORDER BY QUANTIDADE DESC";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function buscaTipoLocal()
    {

        $sql = "SELECT NRTIPOLOCALCLI, NMTIPOLOCALCLI
                  FROM FCM_TIPOLOCALCLI";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function buscaSetor()
    {

        $sql = "SELECT NMSETOR,NRSETOR  
                FROM FCM_SETOR";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function getDadosAcesso($param)
    {

        $sql = "SELECT FUNC.CDOPERADOR, RELFUNC.NRPERFILACESSO, PERF.IDDIRECIONAQRCODE
                FROM OPERADOR FUNC
                  JOIN FCM_RELACFUNCPERFACESS RELFUNC
                  ON RELFUNC.CDOPERADOR = FUNC.CDOPERADOR
                  JOIN FCM_PERFILACESSO PERF
                  ON RELFUNC.NRPERFILACESSO = PERF.NRPERFILACESSO
                WHERE FUNC.CDOPERADOR = " . $param . "";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function getlocalUrlVistoria($param)
    {
        $sql = "SELECT
                 NRGERENCIAMENTOCHK,
                 DTHORAAGEND,
                 NMLOCALCLIENTE,
                 NMLOCALPAI 
              FROM
                 (
                    SELECT
                       GCHK.NRGERENCIAMENTOCHK,
                       GCHK.DTHORAAGEND,
                       LC.NMLOCALCLIENTE,
                       LCP.NMLOCALCLIENTE AS NMLOCALPAI 
                    FROM
                       FCM_GERENCIAMENTOCHK GCHK 
                       JOIN
                          FCM_LOCALCLI LC 
                          ON LC.NRLOCALCLIENTE = GCHK.NRLOCALCLIENTE 
                       JOIN
                          FCM_LOCALCLI LCP 
                          ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI 
                       JOIN
                          OPERADOR FUNC 
                          ON GCHK.CDOPERADOR = FUNC.CDOPERADOR 
                       JOIN
                          FCM_CHECKLISTAGEND CA 
                          ON CA.NRCHECKLISTAGEND = GCHK.NRCHECKLISTAGEND 
                    WHERE
                       GCHK.NRLOCALCLIENTE = " . $param['NRLOCALCLIENTE'] . " 
                       AND IDSITUACAOGERCHK = 1 
                       AND IDSITUACAOAGEND = 4 
                       AND GCHK.CDOPERADOR = " . $param['userLogado'] . " 
                    ORDER BY
                       GCHK.DTHORAAGEND 
                 )
                 VISTORIA 
              WHERE
                 ROWNUM = 1";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function getlocalUrlTarefa($param)
    {
        $sql = "SELECT
                 NRCHECKLISTAGEND,
                 IDSITUACAOAGEND,
                 DTHORAAGEND 
              FROM
                 (
                    SELECT
                       NRCHECKLISTAGEND,
                       IDSITUACAOAGEND,
                       DTHORAAGEND 
                    FROM
                       FCM_CHECKLISTAGEND 
                    WHERE
                       IDSITUACAOAGEND = 1 
                       AND CDOPERADOR = " . $param['userLogado'] . " 
                       AND NRLOCALCLIENTE = " . $param['NRLOCALCLIENTE'] . " 
                    ORDER BY
                       DTHORAAGEND
                 )
                 TAREFAS 
              WHERE
                 ROWNUM = 1";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function getVistoriaSemVinculo($param)
    {
        $sql = "SELECT
                 NRGERENCIAMENTOCHK,
                 DTHORAAGEND,
                 NMLOCALCLIENTE,
                 NMLOCALPAI 
              FROM
                 (
                    SELECT
                       GCHK.NRGERENCIAMENTOCHK,
                       GCHK.DTHORAAGEND,
                       LC.NMLOCALCLIENTE,
                       LCP.NMLOCALCLIENTE AS NMLOCALPAI 
                    FROM
                       FCM_GERENCIAMENTOCHK GCHK 
                       JOIN
                          FCM_LOCALCLI LC 
                          ON LC.NRLOCALCLIENTE = GCHK.NRLOCALCLIENTE 
                       JOIN
                          FCM_LOCALCLI LCP 
                          ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI 
                       JOIN
                          OPERADOR FUNC 
                          ON GCHK.CDOPERADOR = FUNC.CDOPERADOR 
                       JOIN
                          FCM_CHECKLISTAGEND CA 
                          ON CA.NRCHECKLISTAGEND = GCHK.NRCHECKLISTAGEND 
                    WHERE
                       GCHK.NRLOCALCLIENTE = " . $param['NRLOCALCLIENTE'] . " 
                       AND IDSITUACAOGERCHK = 1 
                       AND IDSITUACAOAGEND = 4 
                       AND GCHK.CDOPERADOR = NULL 
                    ORDER BY
                       GCHK.DTHORAAGEND 
                 )
                 VISTORIA 
              WHERE
                 ROWNUM = 1";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function getCriterioNaoConformidadeByGestor($params)
    {
        $whereClausules = "";
        $useParams = false;
        if (array_key_exists("NRLOCALCLIENTE", $params)) {
            $whereClausules .= " AND loc.NRLOCALCLIENTE = :NRLOCALCLIENTE";
            $useParams = true;
        }
        if (array_key_exists("NRTIPOLOCALCLI", $params)) {
            $whereClausules .= " AND loc.NRTIPOLOCALCLI = :NRTIPOLOCALCLI";
            $useParams = true;
        }
        if (array_key_exists("NRSETOR", $params)) {
            $whereClausules .= " AND loc.NRSETOR = :NRSETOR";
            $useParams = true;
        }
        if (array_key_exists("DATEBEGIN", $params) || array_key_exists("DATEEND", $params)) {
            if (array_key_exists("DATEBEGIN", $params) && array_key_exists("DATEEND", $params)) {
                $whereClausules .= " AND TRUNC(c.DTHORAAGEND) BETWEEN TO_DATE('" . $params["DATEBEGIN"] . "' , 'DD/MM/YYYY') AND TO_DATE('" . $params["DATEEND"] . "' , 'DD/MM/YYYY')";
                unset($params["DATEBEGIN"]);
                unset($params["DATEEND"]);
            } elseif (array_key_exists("DATEBEGIN", $params)) {
                $whereClausules .= " AND TRUNC(c.DTHORAAGEND) >= TO_DATE('" . $params["DATEBEGIN"] . "' , 'DD/MM/YYYY')";
                unset($params["DATEBEGIN"]);
            } elseif (array_key_exists("DATEEND", $params)) {
                $whereClausules .= " AND TRUNC(c.DTHORAAGEND) <= TO_DATE('" . $params["DATEEND"] . "', 'DD/MM/YYYY')";
                unset($params["DATEEND"]);
            }
            $useParams = true;
        }
        $sql = "SELECT hc.CDOPERADORPAI, ct.DSCRITERIOTAREFA, func.NMOPERADOR,
          func.CDOPERADOR
          FROM FCM_CHECKLISTAGEND c
          INNER JOIN FCM_TAREFAAGEND ta
          ON c.NRCHECKLISTAGEND = ta.NRCHECKLISTAGEND
          INNER JOIN FCM_CRITERIOTARAGEND crit
          ON crit.NRTAREFAAGEND = ta.NRTAREFAAGEND
          INNER JOIN FCM_CRITERIOTAREFACHK critchk
          ON crit.NRCRITERIOTAREFACHK = critchk.NRCRITERIOTAREFACHK
          INNER JOIN FCM_CRITERIOTAREFA ct
          ON critchk.NRCRITERIOTAREFA = ct.NRCRITERIOTAREFA
          INNER JOIN OPERADOR func
          ON func.CDOPERADOR = c.CDOPERADOR
          INNER JOIN FCM_FUNCIONARIOSHIERARQ hc
          ON hc.CDOPERADOR = func.CDOPERADOR
          INNER JOIN FCM_HIERARQUIAFUNC hcfunc
          ON hcfunc.NRHIERARQUIAFUNC = hc.NRHIERARQUIAFUNC
          INNER JOIN FCM_LOCALCLI loc
          ON loc.NRLOCALCLIENTE = c.NRLOCALCLIENTE
          WHERE hcfunc.IDATIVO LIKE 'S'";
        if ($useParams) {
            $sql .= $whereClausules;
            return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
        } else {
            return $this->connection->executeQuery($sql)->fetchAllAssociative();
        }
    }
}
