<?php

namespace FM\Service;

use FM\Factory\ConformidadesFactory;
use Teknisa\Libs\Util\Environment;

class ConformidadesService
{

    protected $ConformidadesFactory;
    protected $Environment;

    public function __construct(ConformidadesFactory $ConformidadesFactory, Environment $Environment)
    {
        $this->ConformidadesFactory         = $ConformidadesFactory;
        $this->Environment                  = $Environment;
    }

    // função para buscar os dados do card não conformidades
    public function getDadosCardService($param)
    {
        $parametroFiltro = '';
        if ($param['selectLocal'] != '' && $param['selectLocal'] != null) {
            $parametroFiltro = " AND LC.NRLOCALCLIENTE = " . $param['selectLocal'];
        }
        if ($param['selectTipoLocal'] != '' && $param['selectTipoLocal'] != null) {
            $parametroFiltro = " AND LC.NRTIPOLOCALCLI = " . $param['selectTipoLocal'];
        }
        if ($param['selectSetor'] != '' && $param['selectSetor'] != null) {
            $parametroFiltro = " AND LC.NRSETOR = " . $param['selectSetor'];
        }
        if ($param["selectDataDe"] != null || $param["selectDataAte"] != null) {
            if ($param["selectDataDe"] == null) {
                $parametroFiltro = " AND TRUNC(TAC.DTHORATAREFAGERCHK) <= TO_DATE('" . $param["selectDataAte"] . "', 'DD/MM/YYYY')";
            } elseif ($param["selectDataAte"] == null) {
                $parametroFiltro = " AND TRUNC(TAC.DTHORATAREFAGERCHK) >= TO_DATE('" . $param["selectDataDe"] . "', 'DD/MM/YYYY')";
            } else {
                $parametroFiltro = " AND TRUNC(TAC.DTHORATAREFAGERCHK) BETWEEN TO_DATE('" . $param["selectDataDe"] . "', 'DD/MM/YYYY') AND TO_DATE('" . $param["selectDataAte"] . "', 'DD/MM/YYYY')";
            }
        }
        $dados = $this->ConformidadesFactory->getDadosCardFactory($parametroFiltro);

        $locais = [];
        foreach ($dados as $dadosCard) {
            if (!(isset($locais[$dadosCard["NMLOCAL"]]))) {
                $locais[$dadosCard["NMLOCAL"]] = [];
            }
            if (!(in_array($dadosCard["NMCRITERIOTARGERCHK"], $locais[$dadosCard["NMLOCAL"]]))) {
                $locais[$dadosCard["NMLOCAL"]][] = $dadosCard["NMCRITERIOTARGERCHK"];
            }
        }
        return $locais;
    }

    // função para buscar os dados do card principais não conformidades
    public function getDadosCardPrincipaisNaoConformidades($param)
    {
        $parametro = '';
        if ($param["selectDataDe"] != null || $param["selectDataAte"] != null) {
            if ($param["selectDataDe"] == null) {
                $parametro = " AND TRUNC(TGCHK.DTHORATAREFAGERCHK) <= TO_DATE('" . $param["selectDataAte"] . "', 'DD/MM/YYYY')";
            } elseif ($param["selectDataAte"] == null) {
                $parametro = " AND TRUNC(TGCHK.DTHORATAREFAGERCHK) >= TO_DATE('" . $param["selectDataDe"] . "', 'DD/MM/YYYY')";
            } else {
                $parametro = " AND TRUNC(TGCHK.DTHORATAREFAGERCHK) BETWEEN TO_DATE('" . $param["selectDataDe"] . "', 'DD/MM/YYYY') AND TO_DATE('" . $param["selectDataAte"] . "', 'DD/MM/YYYY')";
            }
        }

        $dados = $this->ConformidadesFactory->getDadosCardPrincipaisNaoConformidades($parametro);

        return $dados;
    }
    // função para buscar os dados de Tipo Local
    public function buscaTipoLocal()
    {

        $tipoLocal = $this->ConformidadesFactory->buscaTipoLocal();

        return $tipoLocal;
    }

    // função para buscar os dados dos Setores
    public function buscaSetor()
    {

        $setor = $this->ConformidadesFactory->buscaSetor();

        return $setor;
    }

    public function getDadosAcesso($param)
    {
        $parametro = $param['userLogado'];
        return $this->ConformidadesFactory->getDadosAcesso($parametro);
    }

    public function getlocalUrl($param)
    {
        $perfil = $param['perfil'];
        if ($perfil == 12) {
            $paramUrl = $this->ConformidadesFactory->getlocalUrlVistoria($param);
            return $paramUrl;
        } else {
            $paramUrl = $this->ConformidadesFactory->getlocalUrlTarefa($param);
            return $paramUrl;
        }
    }

    public function getTarefaVistoriaNaoAlocado($param)
    {
        $perfil = $param['perfil'];
        if ($perfil == 12) {
            $paramUrl = $this->ConformidadesFactory->getVistoriaSemVinculo($param);
            return $paramUrl;
        }
    }

    public function getCriterioNaoConformidadeByGestor($params)
    {
        $data = $this->ConformidadesFactory->getCriterioNaoConformidadeByGestor($params);
        return $data;
    }
}
