<?php
namespace Teknisa\Model\Geral\Repositories;

use OrganizationsManagement\Util\Utilities;

class Tabela extends \Doctrine\ORM\EntityRepository {

    public function getTables($conditions, $limit, $offset) {
        $query = <<<SQL
        SELECT *
          FROM (SELECT NMTABELABD AS NAME, NMTABELABD AS TABLE_NAME,
                       DSTABELABD AS DESCRIPTION,
                       IDATIVO AS ACTIVE,
                       DSIDSEQUENCIAL AS SEQUENTIAL
                  FROM TABELA)
            WHERE 1 = 1
                  $conditions
         ORDER BY TABLE_NAME ASC
SQL;

        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    public function getAllTables($conditions, $limit, $offset) {
        $query = <<<SQL
        SELECT  *
          FROM (SELECT TABLE_NAME
                  FROM USER_TABLES
                 WHERE TABLE_NAME NOT IN (SELECT NMTABELABD 
                                            FROM TABELA))
         WHERE 1 = 1
               $conditions
      ORDER BY TABLE_NAME ASC
SQL;

        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    public function getTableByName($tableName, $orgId) {
        $query = <<<SQL
            SELECT *
              FROM TABELA
             WHERE NMTABELABD = :TABLE_NAME
               AND NRORG = :NRORG
SQL;
        $params = array(
            'TABLE_NAME' => $tableName,
            'NRORG' => $orgId
        );
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return !empty($result) ? $result[0] : null;
    }
}